/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Directive, EventEmitter, HostListener, Input, Output } from '@angular/core';
import { FormGroup } from '@angular/forms';
/**
 * @record
 */
export function NrfSubmitData() { }
function NrfSubmitData_tsickle_Closure_declarations() {
    /** @type {?} */
    NrfSubmitData.prototype.nrfForm;
    /** @type {?} */
    NrfSubmitData.prototype.formData;
    /** @type {?} */
    NrfSubmitData.prototype.entity;
    /** @type {?} */
    NrfSubmitData.prototype.formGroup;
    /** @type {?} */
    NrfSubmitData.prototype.event;
}
/**
 * A component to abstract the form implementation
 *
 * It holds the validation and the submit logic
 *
 * \@example
 * <form nrfForm (nrfSubmit)="aCallback($event)">
 *  // Inputs
 * </form>
 */
var NrfFormDirective = /** @class */ (function () {
    /**
     * @ignore
     */
    function NrfFormDirective() {
        /**
         * A function that will be called when the form is valid and a submit event is triggered
         * by a button click or programmatically.
         */
        this.nrfSubmit = new EventEmitter();
        this.formGroup = new FormGroup({});
    }
    /**
     * Init an empty nrfEntity, in case none where provided.
     * @return {?}
     */
    NrfFormDirective.prototype.ngOnInit = function () {
        if (!this.nrfEntity) {
            this.nrfEntity = {};
        }
        this.formData = this.cloneDeep(this.nrfEntity);
    };
    /**
     * @return {?}
     */
    NrfFormDirective.prototype.ngOnDestroy = function () {
        this.nrfSubmit.complete();
    };
    /**
     * # Should not be called directly!
     * This method wraps the form validation and call [onSubmit]{\@link NrfFormDirective#nrfSubmit}
     * @param {?} $event
     * @return {?}
     */
    NrfFormDirective.prototype.formSubmitWrapper = function ($event) {
        $event.preventDefault();
        if (!this.formGroup.valid) {
            return;
        }
        this.nrfSubmit.emit({
            nrfForm: this,
            formData: this.formData,
            entity: this.nrfEntity,
            formGroup: this.formGroup,
            event: $event,
        });
    };
    /**
     * @param {?} target
     * @return {?}
     */
    NrfFormDirective.prototype.cloneDeep = function (target) {
        var _this = this;
        if (!target || typeof target !== 'object') {
            return target;
        }
        if (Array.isArray(target)) {
            return target.map(this.cloneDeep);
        }
        return Object.keys(target).reduce(function (props, key) {
            props[key] = _this.cloneDeep(target[key]);
            return props;
        }, {});
    };
    return NrfFormDirective;
}());
export { NrfFormDirective };
NrfFormDirective.decorators = [
    { type: Directive, args: [{
                selector: 'form[nrfForm]',
                exportAs: 'nrfForm',
            },] },
];
/** @nocollapse */
NrfFormDirective.ctorParameters = function () { return []; };
NrfFormDirective.propDecorators = {
    "nrfEntity": [{ type: Input },],
    "nrfSubmit": [{ type: Output },],
    "formSubmitWrapper": [{ type: HostListener, args: ['submit', ['$event'],] },],
};
function NrfFormDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    NrfFormDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    NrfFormDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    NrfFormDirective.propDecorators;
    /**
     * Represents an Entity Model that comes from Database
     * @type {?}
     */
    NrfFormDirective.prototype.nrfEntity;
    /**
     * A function that will be called when the form is valid and a submit event is triggered
     * by a button click or programmatically.
     * @type {?}
     */
    NrfFormDirective.prototype.nrfSubmit;
    /**
     * Form group will hold all inputs within this form.
     *
     * Every input should register itself to this form group.
     *
     * The data in this form group will not be sent to backend, just form validations and input management.
     * @type {?}
     */
    NrfFormDirective.prototype.formGroup;
    /**
     * The form data representing all inputs
     * @type {?}
     */
    NrfFormDirective.prototype.formData;
}
//# sourceMappingURL=form.directive.js.map
